functor Id (structure SymTab: HASH
	    structure InvSymTab: TABLE
	    sharing type SymTab.elem = string
	        and type InvSymTab.key = int
	   ) : ID =
struct

val symtab = ref SymTab.empty;
val invsymtab = ref (InvSymTab.empty: string InvSymTab.table);

val DEBUG = ref false;

type T = int

exception IdBug

fun intern (s:string) = 
      let val _ = if not (SymTab.exists(s,!symtab))
      			 then symtab := SymTab.add(s, (!symtab))
      			 else ()
          val i_opt = SymTab.find (s, (!symtab))
      in
         case i_opt of
           NONE => raise IdBug
         | SOME(i) => 
             (invsymtab := InvSymTab.insert((i,s), (!invsymtab));
              i)
      end

fun hashcode i = i

exception UnknownId

fun tostr (i:T) : string = 
	let val s_opt = InvSymTab.find (i, (!invsymtab))
	in
	    case s_opt of
	       NONE => raise UnknownId
	     | SOME(s) => s
	end

val newvarcount = ref 0;
fun reset_new_counter() = (newvarcount := 0)

fun new_from i = let 
    fun find_suffix() = let
          val _ = newvarcount := !newvarcount + 1
          val name = i ^ "_" ^ (makestring (!newvarcount))
          in if SymTab.exists(name,!symtab)
               then find_suffix()
               else intern name
          end
    in if not (SymTab.exists(i,!symtab))
          then intern i
          else find_suffix()
    end

fun new() = new_from "temp"

fun == (i:T) (i':T) = (i = i')

fun lexlt (i:T) (i':T) = ((tostr i) < (tostr i'))

fun lookup_field i []             = NONE
  | lookup_field i ((i',v)::rest) = if (== i i') 
  				       then SOME(v)
  				       else lookup_field i rest

end
