functor ListUtils() : LISTUTILS = struct

fun mapunit f l = 
  let fun mu [] = ()
        | mu (hd::tl) = (f hd; mu tl)
  in mu l
  end

fun mapunit_tuple f betw ts =
  let fun mut [] = ()
        | mut [e] = f e
        | mut (e::tl) = (f e; betw(); mut tl)
  in mut ts
  end

fun mapfold fm ff z =
  let fun m []       = z
        | m (hd::tl) = ff (fm hd) (m tl)
  in m
  end

fun memq eq l e =
  let fun m [] = false
        | m (hd::tl) = (eq e hd) orelse (m tl)
  in m l
  end

exception Assoc

fun assoc eq l e =
  let fun m [] = raise Assoc
        | m ((key,hd)::tl) = if (eq e key) then hd else (m tl)
  in m l
  end

fun mapappend f l =
  let fun ma [] = []
        | ma (hd::tl) = (f hd) @ (ma tl)
  in ma l
  end

fun mapappend_tuple f betw l =
  let fun ma [] = []
        | ma [e] = f e
        | ma (hd::tl) = (f hd) @ [betw] @ (ma tl)
  in ma l
  end

fun filter b l =
  let fun f [] = []
        | f (hd::tl) = if (b hd) then hd::(f tl) else f tl
  in f l
  end

exception UnbalancedZip
fun zip [] [] = []
  | zip (x::xs) (y::ys) = (x,y) :: (zip xs ys)
  | zip _ _ = raise UnbalancedZip

fun forall f = mapfold f (fn x => fn y => x andalso y) true

fun forallpairs f l1 l2 = 
    mapfold f (fn x => fn y => x andalso y) true (zip l1 l2)
    handle UnbalancedZip => false

fun forsome f = mapfold f (fn x => fn y => x orelse y) false

end
