signature PARSE = sig

(* High-level functions for invoking parsers *)

structure ParseRes : PARSERESCOMMON

(* The interactive prompt character *)
val prompt_char: string ref;

(* Called before calling the parser on a new input stream *)
val begin_parser_context : string -> unit

(* Called when a stream has been fully parsed *)
val end_parser_context : unit -> unit

(* Parse a single item from a file *)
val file_parse: string -> ParseRes.T;

(* Parse a single item from a stream *)
val stream_parse: instream -> ParseRes.T;

(* Parse a single item from the standard input *)
val top_parse: unit -> ParseRes.T;

end  (* signature PARSE *)

