Class = 
  Fun(M:*->*)
  Fun(R:*)
    All(FinalR)
         (FinalR->R)
      -> (FinalR->R->FinalR)
      -> M(FinalR);

new =
  fun(M<Top(*->*))
  fun(R)
  fun(s:R)
  fun(cl: Class M R)
    < R, 
      {state = s,
       methods = cl
                   R
                   (fun(s:R) s)
                   (fun(s:R) fun(s':R) s')}
    >: Object(M);

extend = 
  fun(SuperM < Top(*->*))                     % superclass interface
  fun(SuperR)                                 % superclass representation
  fun(NewM < SuperM)                          % new class interface
  fun(NewR)                                   % new class representation
  fun(superClass: Class SuperM SuperR)        % the superclass        
  fun(build:                                  % "increment" fun, with args...
          All(FinalR)                            % final representation
          (FinalR->NewR) ->                      % extractor
          (FinalR->NewR->FinalR) ->              % overwriter
          (SuperM(FinalR)) ->                    % superclass methods
          (NewM(FinalR)))                        % ...returning new methods
  fun(get: NewR->SuperR)                      % new->super extractor
  fun(put: NewR->SuperR->NewR)                % new<-super overwriter
   % Build the extended class...
   (fun(FinalR)                          
    fun(g: FinalR->NewR)
    fun(p: FinalR->NewR->FinalR)
      build FinalR g p
         (superClass FinalR
           (fun(s:FinalR) get(g(s))) 
           (fun(s:FinalR) fun(s':SuperR) p s (put (g s) s'))));

PointM = Fun(R:*) {|setX:R->Int->R, getX:R->Int|};
PointR = {|x:Int|};
PointClass = Class PointM PointR;

CPointM = Fun(R:*) {|setX:R->Int->R, getX:R->Int,
                     setC:R->Color->R, getC:R->Color|};
CPointR = {|x:Int, color:Color|};
CPointClass = Class CPointM CPointR;

p_class =
   fun(FinalR)
   fun(get: FinalR->PointR)
   fun(put: FinalR->PointR->FinalR)
     {setX = fun(s:FinalR) fun(i:Int) put s {x=i},
      getX = fun(s:FinalR) (get s).x};

cp_class =
  extend PointM PointR CPointM CPointR p_class
  (fun(FinalR)
   fun(get: FinalR->CPointR)
   fun(put: FinalR->CPointR->FinalR)
   fun(super: PointM(FinalR))
    {setX = super.setX,
     getX = super.getX,
     setC = fun(s:FinalR) fun(c:Color) 
               put s {x=(get s).x, color=c},
     getC = fun(s:FinalR) (get s).color})
  (fun(s:CPointR) {x=s.x})
  (fun(s:CPointR) fun(s':PointR) {x=s'.x, color=s.color});

c = new CPointM CPointR {x=1,color=red} cp_class;

