signature TYPHELPER = sig

structure Typ: TYP
structure TEnv: TENV
structure Globals: GLOBALS
sharing Typ.Globals = Globals
    and TEnv.Typ = Typ
include GLOBALS

datatype PreKind = 
	    PRESTAR
	  | PREKARROW of PreKind * PreKind

and PreTyp = 
	    PRETVAR of Id.T
	  | PREABST of Id.T * PreKind * PreTyp
	  | PREAPPT of PreTyp * PreTyp
	  | PREARROW of PreTyp * PreTyp
	  | PREALL of Id.T * PreTyp * PreTyp
	  | PRESOME of Id.T * PreTyp * PreTyp
	  | PRETOP of PreKind
	  | PRERCD of (Id.T * PreTyp) list

val debruijnify: TEnv.T -> PreTyp -> Typ.T
(* val normalize: TEnv.T -> Typ.T -> Typ.T *)
val whn: TEnv.T -> Typ.T -> Typ.T
val keq: TEnv.T -> Typ.K -> Typ.K -> bool
val eq: TEnv.T -> Typ.T -> Typ.T -> bool
val betaeq: TEnv.T -> Typ.T -> Typ.T -> bool

val kprt: TEnv.T -> Typ.K -> unit
val prt: TEnv.T -> Typ.T -> unit
val prt_outer: TEnv.T -> Typ.T -> unit
val prt_nested: TEnv.T -> Typ.T -> unit

val prt_tenv: TEnv.T -> unit

end




